# Chapter2.py
import pandas as pd

# Create a new dataframe from a csv
file_csv = 'firesData.csv' # 9300 rows

df_firesData = pd.read_csv(file_csv)

# print(df_firesData.info())
'''
 #   Column          Non-Null Count  Dtype
---  ------          --------------  -----
 0   state           9300 non-null   object
 1   fire_year       9300 non-null   int64
 2   fire_month      9300 non-null   int64
 3   acres_burned    9300 non-null   float64
 4   days_burning    9300 non-null   int64
 5   fire_count      9300 non-null   int64
 6   dollar_damage   9300 non-null   int64
 7   dollar_rebuilt  9300 non-null   int64
 '''

# Define a vaiable for dollars per acre burned
dollars_acreBurned = 1.25 # arithmetic ops int * float

df_firesData['dollar_damage'] = df_firesData['acres_burned'] * dollars_acreBurned

# print(df_firesData.head())

# shape the month int to a string
import calendar
df_firesData['month_to_string']  = df_firesData['fire_month'].apply(
    lambda m: calendar.month_name[m]
) # apply

print(df_firesData.head())

# aggreates -> sum, count, min, max, floor, ceil, stdev, ....
# summary table of aggregates -> describe()
# print(df_firesData.describe())

# Best Practice -> groupby()
## Group By State -> Sum(dollar_damage)
## AK -> 1995-2015 All months -> $
### Actual 9300 entries -> Expected Rows -> between 1 - 50
df_state_damage_sum = df_firesData.groupby('state', as_index=False)['dollar_damage'].sum()

# print(df_state_damage_sum)

# index state and fire_year -> columns as value
df_firesData = df_firesData.set_index(['state','fire_year'])

print(df_firesData)

# Filter / Query the Data -> query()
## Do we keep the original 9300 entries -> query(new DF)
## or inplace=True to use the existing
month_query = int(
    input("Month to query (as int): ")
)

# expression "    == 'value:string'  "

query_string = f"fire_month == {month_query}"

df_firesData_monthQuery = df_firesData.query(query_string)

print(df_firesData_monthQuery)

## What if we need to query MULTIPLE values from the SAME Series
### Build a list of months as string, user input
months_query = [] # Empty List in Memory
while True:
    month = input("Enter Month to query: ").title() # May, June
    months_query.append(month)

    answer = input("Do you want to add another month (yes/no): ")
    if answer.lower() == 'no':
        break

print(months_query) # ["May","July"]

query_list = f"month_to_string in {months_query}"

df_firesData_monthQuery_list = df_firesData.query(query_list)

print(df_firesData_monthQuery_list)

'''
all combinations to use in query()
SINGLE value SINGLE Series  month == 5
MULTIPLE values[List] Single Series month_to_string == ['May','June']
SINGLE value MULTIPLE series (logical operators) year == 1992 and state == 'AK'
MULTIPLE values[List] MULTIPLE Series year in [years] and state in [states]

Best Practice -> query_string = f"varname == {template variables}"
THEN -> query(query_string)
'''
print("=== Final Exercise Chapter 2 ===")
# User inputted list of years
years = []
while True:
    year = int(
        input("Enter year between 1995-2015 or '0' when finished: ")
    )

    if year == 0:
        break

    years.append(year)

# User inputted list of states
states = []
while True:
    state = input("Enter state as 2 Alpha AK,MI, etc or 'done' when finished: ")  # web page -> drop down, check boxed, radio desktop: select

    if state == 'done':
        break

    states.append(state) # AK, IA, FL

# query_string for years = [list] and state = [list]
print(years)
print(states)

query_years_states = f"state in {states} and fire_year in {years}"

# query() firedata
df_firesData_final = df_firesData.query(query_years_states)

# print()
print(df_firesData_final)


# EOF Chapter2.py